// Generated by CoffeeScript 2.7.0
(function() {
  var _;

  _ = require('lodash');

  module.exports = function(opts = {}) {
    /*
    Produces a RelaxNG schema for the given template. Refs will be resolved using
    the object passed in. If there is a reference to something not defined in the
    schema, then we will attempt to resolve it using the refs object. If it
    exist, we will add a definition of that name and inline the corresponding
    snippet.
    */
    var attr, capture, comment, element, parse, relaxng, relaxngAny, text;
    opts = _.cloneDeep(opts);
    opts.types = _.merge({}, require('./model/types'), opts.types || {});
    opts.kindProperty = opts.kindProperty || 'kind';
    opts.prefixes = opts.prefixes || {};
    element = require('./model/element')(opts);
    attr = require('./model/attr')(opts);
    text = require('./model/text')(opts);
    capture = require('./model/capture')(opts);
    comment = require('./model/comment')(opts);
    parse = require('./model/builder')({element, attr, text, comment, capture});
    relaxngAny = element('zeroOrMore').ns('http://relaxng.org/ns/structure/1.0').content(element('choice').content(element('element').content(element('anyName'), element('ref').attrs(attr('name').value('any'))), element('attribute').content(element('anyName')), element('text')));
    relaxng = function(template, refs = {}) {
      var definitions, refElementsFound, refsFound, schema, trackingElement;
      refElementsFound = [];
      trackingElement = function(name) {
        var created;
        created = element(name);
        if (name === 'ref') {
          refElementsFound.push(created);
        }
        return created;
      };
      schema = template.relaxng({
        element: trackingElement,
        attr,
        text
      });
      refsFound = refElementsFound.map(function(ref) {
        var ref1;
        return (ref1 = ref.getAttribute('name')) != null ? ref1.getValue() : void 0;
      });
      definitions = _.uniq(refsFound).map(function(name) {
        if (refs[name] != null) {
          return element('define').attrs(attr('name').value(name)).content(refs[name]);
        } else {
          return element('define').attrs(attr('name').value(name)).content(relaxngAny);
        }
      });
      return element('grammar').ns('http://relaxng.org/ns/structure/1.0').attrs(attr('datatypeLibrary').value('http://www.w3.org/2001/XMLSchema-datatypes')).content(element('start').content(schema), ...definitions).toXML();
    };
    return {element, attr, text, parse, relaxng, capture};
  };

}).call(this);
