// Generated by CoffeeScript 2.7.0
(function() {
  var _, accessor, element, parse, property;

  parse = require('./parse');

  _ = require('lodash');

  accessor = function(gen, desc) {
    return function(key) {
      return {
        set: function(obj, value) {
          return obj[key] = value;
        },
        get: function(obj) {
          return obj[key];
        },
        getOrCreate: function(obj, nextGen) {
          var value;
          if (obj[key] != null) {
            return obj[key];
          } else {
            value = nextGen();
            obj[key] = value;
            return value;
          }
        },
        gen: gen,
        describe: function(type) {
          return desc(key, type);
        }
      };
    };
  };

  property = accessor(function() {
    return {};
  }, function(key, type) {
    return {
      type: 'object',
      keys: {
        [`${key}`]: type
      }
    };
  });

  element = accessor(function() {
    return [];
  }, function(key, type) {
    return {
      type: 'array',
      element: type
    };
  });

  module.exports = {
    of: function(expr) {
      var parsed, segments;
      parsed = parse(expr);
      segments = parsed.map(function(segment) {
        switch (segment.type) {
          case 'element':
            return element(parseInt(segment.index));
          case 'property':
            return property(segment.key);
        }
      });
      return {
        set: function(obj, value) {
          var context;
          context = _.reduce(_.initial(segments), function(acc, segment, index) {
            return segment.getOrCreate(acc, segments[index + 1].gen);
          }, obj);
          return _.last(segments).set(context, value);
        },
        get: function(obj) {
          return _.reduce(segments, function(acc, segment) {
            if (acc != null) {
              return segment.get(acc);
            }
          }, obj);
        },
        descriptor: function(type = {
            type: 'any'
          }) {
          return _.chain(segments).clone().reverse().reduce(function(acc, segment) {
            return segment.describe(acc);
          }, type).value();
        },
        describe: function(target, type) {
          return _.merge(target, this.descriptor(type));
        }
      };
    }
  };

}).call(this);
