// Generated by CoffeeScript 2.7.0
(function() {
  var _, extractValue, parseExpr, types;

  _ = require('lodash');

  ({parseExpr, extractValue} = require('./util'));

  types = require('./types');

  module.exports = function({types}) {
    return function(name) {
      var exposed, meta;
      meta = {
        name: name,
        required: false,
        valueType: types.string
      };
      exposed = {
        required: function() {
          meta.required = true;
          return exposed;
        },
        ns: function(ns) {
          meta.ns = ns;
          return exposed;
        },
        bind: function(...opts) {
          meta.bind = parseExpr(...opts);
          return exposed;
        },
        value: function(value) {
          meta.value = value;
          meta.required = true;
          return exposed;
        },
        sample: function(value) {
          meta.sample = value;
          return exposed;
        },
        getName: function() {
          return meta.name;
        },
        getValue: function() {
          return meta.value;
        },
        generate: function(obj, elem) {
          var value;
          value = extractValue(meta, obj);
          if (value != null) {
            if (meta.ns != null) {
              if (meta.ns !== 'http://www.w3.org/2000/xmlns/') {
                return elem.setAttributeNS(meta.ns, meta.name, meta.valueType.to(value));
              } else {
                return elem.setAttributeNS(meta.ns, meta.name, meta.valueType.to(value));
              }
            } else {
              return elem.setAttribute(meta.name, meta.valueType.to(value));
            }
          }
        },
        extract: function(elem, target, raw) {
          var decoded, value;
          if (meta.bind != null) {
            // We're working around a bug in the version of xmldom we're relying upon
            // Fixed in later versions of xmldom
            value = meta.ns != null ? elem.hasAttributeNS(meta.ns, meta.name) ? elem.getAttributeNS(meta.ns, meta.name) : null : elem.hasAttribute(meta.name) ? elem.getAttribute(meta.name) : null;
            decoded = raw ? value : meta.valueType.from(value);
            if (value != null) {
              return meta.bind.set(target, decoded);
            }
          }
        },
        descriptor: function() {
          var ref;
          return (ref = meta.bind) != null ? ref.descriptor(_.merge({}, meta.valueType.desc, {
            sample: meta.sample != null ? meta.valueType.from(meta.sample) : void 0
          })) : void 0;
        },
        isSet: function(obj) {
          return !meta.bind || (meta.bind.get(obj) != null);
        },
        definedOn: function(elem) {
          var localName, result;
          // Another hack. We need to start remembering the prefix and local name during parsing.
          localName = _.last(meta.name.split(':'));
          result = meta.ns != null ? elem.hasAttributeNS(meta.ns, localName) && ((meta.bind != null) || elem.getAttributeNS(meta.ns, localName) === meta.value) : elem.hasAttribute(meta.name) && ((meta.bind != null) || elem.getAttribute(meta.name) === meta.value);
          return result;
        },
        relaxng: function(ctx) {
          var data, nested, prefix;
          data = meta.value != null ? ctx.element('value').content(ctx.text().value(meta.value)) : meta.valueType.relaxng(ctx);
          nested = ctx.element('attribute').attrs(ctx.attr('name').value(meta.name)).content(data);
          // This is a bit of a hack. First of all, the prefix is known during parsing. We could have kept it.
          // Second: schemawise, it might have been better to use the RelaxNG "ns" attribute.
          // Third: It's a little fishy scan for ':' to see if an attribute is namespaced.
          if (meta.ns && meta.name.indexOf(':') >= 0) {
            [prefix] = meta.name.split(':');
            nested.attrs(ctx.attr(`xmlns:${prefix}`).value(meta.ns));
          }
          if (meta.required) {
            return nested;
          } else {
            return ctx.element('optional').content(nested);
          }
        }
      };
      _.forEach(types, function(value, key) {
        return exposed[key] = function() {
          meta.valueType = value;
          return exposed;
        };
      });
      return exposed;
    };
  };

}).call(this);
