// Generated by CoffeeScript 2.7.0
(function() {
  var DOMParser, _, binding, curlyNS, forAllAttributes, xincludeNS, xsiNS;

  DOMParser = require('@xmldom/xmldom').DOMParser;

  _ = require('lodash');

  binding = require('./binding');

  curlyNS = 'https://github.com/wspringer/cruftless';

  ({xincludeNS, xsiNS} = require('../ns'));

  forAllAttributes = function(node, fn) {
    var i, length, result;
    i = 0;
    length = node.attributes.length;
    result = [];
    while (i <= length - 1) {
      result.push(fn(node.attributes[i]));
      i += 1;
    }
    return result;
  };

  module.exports = function(opts) {
    var attr, capture, comment, element, parse, text;
    ({element, attr, text, comment, capture} = opts);
    parse = function(node, resolve) {
      var attrs, captured, childNodes, content, el, empty, href, next, piNode, xml;
      switch (node.nodeType) {
        case 1:
          if (node.namespaceURI === xincludeNS && node.localName === 'include' && (resolve != null)) {
            href = node.getAttribute('href');
            if (href != null) {
              [xml, next] = resolve(href);
              if (xml != null) {
                return parse(new DOMParser().parseFromString(xml).documentElement, next);
              }
            }
          }
          el = element(node.tagName);
          if (node.hasAttributeNS(xsiNS, 'type')) {
            el.kind(node.getAttributeNS(xsiNS, 'type'));
          }
          if (node.namespaceURI) {
            el.ns(node.namespaceURI);
          }
          childNodes = Array.from(node.childNodes);
          piNode = childNodes.find(function(node) {
            return node.nodeType === 7;
          });
          if ((piNode != null) && piNode.target === 'bind') {
            binding.raw(piNode.data).apply(el);
          }
          if ((piNode != null) && piNode.target === 'capture') {
            captured = capture();
            binding.raw(piNode.data).apply(captured);
            el.content(captured);
          }
          content = childNodes.map(function(node) {
            return parse(node, resolve);
          }).filter(_.negate(_.isUndefined));
          el.content(...content);
          attrs = [];
          forAllAttributes(node, function(item) {
            var res;
            if ((item.namespaceURI === curlyNS && item.localName === 'bind') || (item.name === 'c-bind')) {
              return binding.raw(item.value).apply(el);
            } else if ((item.namespaceURI === curlyNS && item.localName === 'if') || (item.name === 'c-if')) {
              return binding.raw(item.value).apply(el, 'if');
            } else if (item.prefix === 'xmlns' && (item.value === curlyNS || item.value === xincludeNS)) {

            } else {
              // ignore
              res = binding.curly(item.value).apply(attr(item.name));
              if (item.namespaceURI) {
                res.ns(item.namespaceURI);
              }
              return attrs.push(res);
            }
          });
          el.attrs(...attrs);
          return el;
        case 3:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.textContent).apply(text());
          }
          break;
        case 4:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.data).apply(text());
          }
          break;
        case 8:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.textContent).apply(comment());
          }
      }
    };
    return function(xml, resolver) {
      return parse(new DOMParser().parseFromString(xml).documentElement, resolver);
    };
  };

}).call(this);
