// Generated by CoffeeScript 2.7.0
(function() {
  var _, extractValue, parseExpr, types;

  ({parseExpr, extractValue} = require('./util'));

  _ = require('lodash');

  types = require('./types');

  module.exports = function({types, preserveWhitespace}) {
    return function() {
      var exposed, meta;
      meta = {
        required: false,
        valueType: types.string,
        cdata: false
      };
      exposed = {
        cdata: function() {
          meta.cdata = true;
          return exposed;
        },
        required: function() {
          meta.required = true;
          return exposed;
        },
        value: function(value) {
          meta.value = value;
          meta.required = true;
          return exposed;
        },
        isRequired: function() {
          return meta.required;
        },
        bind: function(...opts) {
          meta.bind = parseExpr(...opts);
          return exposed;
        },
        generate: function(obj, context) {
          var node, value;
          value = extractValue(meta, obj);
          node = meta.cdata ? context.ownerDocument.createCDATASection(meta.valueType.to(value)) : context.ownerDocument.createTextNode(meta.valueType.to(value));
          context.appendChild(node);
        },
        matches: function(node) {
          return node.nodeType === 3 || node.nodeType === 4;
        },
        sample: function(value) {
          meta.sample = value;
          return exposed;
        },
        extract: function(node, target, raw) {
          var ref;
          return (ref = meta.bind) != null ? ref.set(target, raw ? node.textContent : meta.valueType.from(node.textContent)) : void 0;
        },
        descriptor: function() {
          var ref;
          return (ref = meta.bind) != null ? ref.descriptor(_.merge({}, meta.valueType.desc, {
            sample: meta.sample != null ? meta.valueType.from(meta.sample) : void 0
          })) : void 0;
        },
        isSet: function(obj) {
          return meta.required || !meta.bind || !(_.isUndefined(meta.bind.get(obj)));
        },
        relaxng: function(ctx) {
          if (meta.value) {
            return ctx.element('value').content(ctx.text(meta.value));
          } else {
            return meta.valueType.relaxng(ctx);
          }
        }
      };
      _.forEach(types, function(value, key) {
        return exposed[key] = function() {
          meta.valueType = value;
          return exposed;
        };
      });
      return exposed;
    };
  };

}).call(this);
